commit cf4086628dd5546cc0efdd5afa102fee6b16385d
Author: John David Anglin <danglin@gcc.gnu.org>
Date:   Wed Sep 18 11:02:32 2024 -0400

    hppa: Add peephole2 optimizations for REG+D loads and stores
    
    The PA 1.x architecture only supports long displacements in
    integer loads and stores.  Floating-point loads and stores
    only support short displacements.  As a result, we have to
    wait until reload is complete before generating insns with
    long displacements.
    
    The PA 2.0 architecture supports long displacements in both
    integer and floating-point loads and stores.
    
    The peephole2 optimizations added in this change are only
    enabled when 14-bit long displacements aren't supported for
    floating-point loads and stores.
    
    2024-09-18  John David Anglin  <danglin@gcc.gnu.org>
    
    gcc/ChangeLog:
    
            * config/pa/pa.h (GENERAL_REGNO_P): Define.
            * config/pa/pa.md: Add SImode and SFmode peephole2
            patterns to generate loads and stores with long
            displacements.

diff --git a/gcc/config/pa/pa.h b/gcc/config/pa/pa.h
index 127a0d1966d..49c798e4933 100644
--- a/gcc/config/pa/pa.h
+++ b/gcc/config/pa/pa.h
@@ -480,6 +480,9 @@ extern rtx hppa_pic_save_rtx (void);
 #define INDEX_REG_CLASS GENERAL_REGS
 #define BASE_REG_CLASS GENERAL_REGS
 
+/* True if register is a general register.  */
+#define GENERAL_REGNO_P(N) ((N) >= 1 && (N) <= 31)
+
 #define FP_REG_CLASS_P(CLASS) \
   ((CLASS) == FP_REGS || (CLASS) == FPUPPER_REGS)
 
